
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <pthread.h>

#define KILO		(1024)  /* a conversion multiplier */
#define STARTBLOCK	(8)     /* in Kbytes */
#define MEMARRAY	(16)    /* in Mbytes */
#define MEMPASS		(4)     /* in Gbytes */

typedef signed long	    S32;
typedef unsigned long	    U32;
typedef double		    F64;

typedef struct pack {
    U32 memarr;
    U32 mempass;
    U32 block;
} pack_t;

void intwr(pack_t *data) {
    U32 passnum, ret, a, b, c;
    F64 start, finish;
    volatile U32 *mem;
    struct timeval timer;

    mem = (U32 *) malloc(data->memarr*KILO*KILO);

    passnum = data->mempass*KILO*KILO/data->block;
    gettimeofday(&timer, NULL);
    start = (F64)timer.tv_sec + ((F64)timer.tv_usec * 1.e-6);
    for(a = 0; a < passnum; a++) {
        for(b = 0; b < data->block*KILO/sizeof(S32); b += 32) {
	    mem[b] = 0;    mem[b+1] = 0;  mem[b+2] = 0;  mem[b+3] = 0;
	    mem[b+4] = 0;  mem[b+5] = 0;  mem[b+6] = 0;  mem[b+7] = 0;
	    mem[b+8] = 0;  mem[b+9] = 0;  mem[b+10] = 0; mem[b+11] = 0;
	    mem[b+12] = 0; mem[b+13] = 0; mem[b+14] = 0; mem[b+15] = 0;
	    mem[b+16] = 0; mem[b+17] = 0; mem[b+18] = 0; mem[b+19] = 0;
	    mem[b+20] = 0; mem[b+21] = 0; mem[b+22] = 0; mem[b+23] = 0;
	    mem[b+24] = 0; mem[b+25] = 0; mem[b+26] = 0; mem[b+27] = 0;
	    mem[b+28] = 0; mem[b+29] = 0; mem[b+30] = 0; mem[b+31] = 0;
	}
    }
    gettimeofday(&timer, NULL);
    finish = (F64)timer.tv_sec + ((F64)timer.tv_usec * 1.e-6);

    ret = (U32)((F64)(data->mempass*KILO)/(finish-start));

    free((U32 *) mem);

    pthread_exit((void *) ret);
}

int main(int argc, char *argv[]) {
    U32 res0 = 0, res1 = 0;
    pack_t data;
    pthread_t thrid0, thrid1;

    data.memarr  = MEMARRAY;
    data.mempass = MEMPASS;
    data.block   = STARTBLOCK;

    printf("%ldGb per pass mode\n\n", data.mempass);
    printf("INTEGER | WRITING %6ld Kb block: ", data.block);

    pthread_create(&thrid0, NULL, (void *)intwr, (void *)&data);
    pthread_create(&thrid1, NULL, (void *)intwr, (void *)&data);

    pthread_join(thrid0, (void *)&res0);
    pthread_join(thrid1, (void *)&res1);

    printf("%ld Mb/s\nres0: %ld\nres1: %ld\n", res0 + res1, res0, res1);

    return(0);   
}
